unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, Grids, StdCtrls;

const
  columnas = 20;
  filas = 10;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DrawGrid1: TDrawGrid;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure Sale1Click(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure genera;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DrawGrid1SelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    pasto1,
    pasto2,
    pasto3,
    tierra,
    hueso,
    craneo,
    huevo : tbitmap;
    pastos : array [0..filas-1, 0..columnas-1] of byte;
    campos : array [0..filas-1, 0..columnas-1] of char;
    dinero : integer;
    encontro_hueso,
    encontro_cabeza,
    encontro_huevo : boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Sale1Click(Sender: TObject);
begin
  application.terminate;
end;

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
begin

  if pastos [row, col] > 0 then
    case pastos [row, col] of
      1 : drawgrid1. canvas. Draw (rect.left, rect.top, pasto1);
      2 : drawgrid1. canvas. Draw (rect.left, rect.top, pasto2);
      3 : drawgrid1. canvas. Draw (rect.left, rect.top, pasto3);
    end
  else
    case campos [row, col] of
      't' : drawgrid1. canvas. Draw (rect.left, rect.top, tierra);
      'h' : drawgrid1. canvas. Draw (rect.left, rect.top, hueso);
      'c' : drawgrid1. canvas. Draw (rect.left, rect.top, craneo);
      'u' : drawgrid1. canvas. Draw (rect.left, rect.top, huevo);
    end;

end;

procedure tform1. genera;

  var
    fila,
    columna,
    dinosauro,
    cuerpo : integer;

begin
  randomize;
  encontro_cabeza := false;

  for fila := 0 to filas - 1 do
  begin

    for columna := 0 to columnas - 1 do
    begin
      pastos [fila, columna] := random (3) + 1;
      campos [fila, columna] := 't';
    end;

  end;

  for dinosauro := 1 to random (3) + 1 do
  begin
    fila := random (filas);
    columna := random (columnas);
    campos [fila, columna] := 'c';

    for cuerpo := 1 to columnas do
    begin

      repeat

        case random (4) of

          0 : begin
            if fila > 0 then dec (fila);
          end;

          1 : begin
            if columna < columnas - 1 then inc (columna);
          end;

          2 : begin
            if fila < filas - 1 then inc (fila);
          end;

          3 : begin
            if columna > 0 then dec (columna);
          end;

        end;

      until campos [fila, columna] <> 'c';

      campos [fila, columna] := 'h';
    end;

    repeat
      fila := random (filas);
      columna := random (columnas);
    until campos [fila, columna] = 't';

    campos [fila, columna] := 'u';
  end;

{  repeat
    fila := random (filas);
    columna := random (columnas);
  until campos [fila, columna] = 'h';

  pastos [fila, columna] := false;}
  drawgrid1.invalidate;
  messagedlg ('Han descubierto un hueso de dinosaurio!'#10#13#10#13+
    'El museo requiere su ayuda para escavar el terreno.', mtinformation,
    [mbok], 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dinero := 500;
  encontro_hueso := false;
  encontro_cabeza := false;
  encontro_huevo := false;
  panel1. caption := format ('Fondos : %d', [dinero]);
  pasto1 := tbitmap. create;
  pasto2 := tbitmap. create;
  pasto3 := tbitmap. create;
  tierra := tbitmap. create;
  hueso := tbitmap. create;
  craneo := tbitmap. create;
  huevo := tbitmap. create;
  pasto1. LoadFromFile ('pasto1.bmp');
  pasto2. LoadFromFile ('pasto2.bmp');
  pasto3. LoadFromFile ('pasto3.bmp');
  tierra. LoadFromFile ('tierra.bmp');
  hueso. LoadFromFile ('hueso.bmp');
  craneo. LoadFromFile ('craneo.bmp');
  huevo. LoadFromFile ('huevo.bmp');
  genera;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  pasto1. free;
  pasto2. free;
  pasto3. free;
  tierra. free;
  hueso. free;
  craneo. free;
  huevo. free;
end;

procedure TForm1.DrawGrid1SelectCell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin

  if pastos [row, col] > 0 then
  begin
    pastos [row, col] := 0;

    case campos [row, col] of
      't' : dec (dinero, 100);

      'h' : begin
        inc (dinero, 100);

        if encontro_hueso = false then
        begin
          encontro_hueso := true;
          messagedlg ('Es un hueso de dinosaurio!'#10#13#10#13 +
            'El cuerpo y la cabeza deben estar alrededor.', mtinformation,
            [mbok], 0);
        end;

      end;

      'c' : begin
        inc (dinero, 500);

        if encontro_cabeza = false then
        begin
          encontro_cabeza := true;
          messagedlg ('Es la cabeza del dinosaurio!'#10#13#10#13 +
            'Has ganado esta misin.', mtinformation, [mbok], 0);
        end;

      end;

      'u' : begin
        inc (dinero, 1000);

        if encontro_huevo = false then
        begin
          encontro_huevo := true;
          messagedlg ('Es un huevo de dinosaurio!'#10#13#10#13 +
            'Todos los dinosauros ponen huevos.', mtinformation,
            [mbok], 0);
        end;

      end;

    end;

    panel1. caption := format ('Fondos : %d', [dinero]);
  end;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  application. terminate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if encontro_cabeza then
  begin
    genera;
    inc (dinero, 500);
    panel1. caption := format ('Fondos : %d', [dinero]);
  end else
    messagedlg ('Primero debe encontrar la cabeza.', mtinformation,
      [mbok], 0);
end;

end.
